unit tradunet;

interface

implementation

    function traduzURL (url: string; out protocolo, nomeComput: string;
                                     out porta: integer;
                                     out recurso: string): boolean;
    var
        i: integer;
        erro: integer;
        s: string;
    begin
        traduzURL := false;

        url := trim(url);
        i := pos('://' , url);
        if i = 0 then
            protocolo := 'http'
        else
            begin
                protocolo := copy(url, 1, (i-1));
                url := copy(url, (i+3), 999);
            end;
        protocolo := upperCase(protocolo);

        i := pos('/', url);
        if i = 0 then
            i := pos('?', url);

        if i = 0 then
            begin
                recurso := '';
                nomeComput := url;
            end
        else
            begin
                nomeComput := copy(url, 1, (i-1));
                recurso := copy(url, i, 999);
                if copy(recurso, 1,1) = '?' then
                    recurso := '/' + recurso;
            end;

        i := pos(':', nomeComput);
        if i <> 0 then
            begin
                s := copy(nomeComput, (i+1), 999);
                nomeComput := copy(nomeComput, 1, i-1);
                val (s, porta, erro);
                if erro <> 0 then
                    exit;
            end
        else
            if protocolo = 'HTTPS' then
                porta := 443
            else
                porta := 80;

        if recurso = '' then
            recurso := '/';

        i := pos('?', recurso);
        if i <> 0 then
            recurso := copy(recurso, 1,i) + EncodeURL(copy(recurso, i+1,999));

        traduzURL := true;
    end;

{--------------------------------------------------------}

    function pegaHeader (protocolo, nomeComput: string; porta: integer; recurso: string;
                         out codRetorno: integer;
                         out novaUrl: string;
                         out pbuf: PbufRede;
                         out soquete: integer): boolean;

    var s: string;
        i: integer;
        header: TStringList;
        aEnviar: string;

    begin
        pegaHeader := false;
        codRetorno := 500;
        novaUrl := '';

        if ansiUpperCase(protocolo) = 'HTTPS' then
            soquete := abreConexaoSSL (nomeComput, porta)
        else
            soquete := abreConexao (nomeComput, porta);
        if soquete < 0 then
            begin
                sintWriteln (ERRO_CONEXAO);  {'Erro de conexao' ou seja, soquete menor que 0};
                exit;
            end;

        aEnviar :=
            'GET ' + EncodeURL(recurso) + ' HTTP/1.0' + CRLF +
            'UA-CPU: x86' + CRLF +
            'Connection: Close' + CRLF +
            'Accept-Language: pt-br' + CRLF +
            'User-Agent: Scriptvox ' + VERSAO_DVSCRIPT + CRLF +
            'Host: ' + nomeComput + CRLF +
            CRLF;

        statusUltIO := ord (writeRede(soquete, aEnviar));

        pBuf := inicBufRede (soquete);

        header := TStringList.Create;
        repeat
            statusUltIO := ord (not readlnBufRede (pbuf, s, 30));
            header.add(s);
        until (statusUltIO <> 0) or (s = '');

        if copy(header[0], 1,4) <> 'HTTP' then   // erro no servidor
            begin
                sintWriteln (ERRO_HTTP);
                header.Free;
                fechaConexao(soquete);
                fimBufRede(pbuf);
                pbuf := NIL;
                exit;
            end;

        s := header[0];
        i := pos(' ', s);
        codRetorno := StrToInt(copy(s, i+1, 3));

        if (codRetorno div 100) = 3  then  // relocators
            begin
                // pega o location
                for i := 0 to (header.Count-1) do
                    begin
                        if pos('LOCATION:', upperCase(header[i])) = 1 then
                            novaUrl := trim(copy(header[i], 10 , 999));
                    end;
                fimBufRede (pbuf);
                fechaConexao(soquete);
            end;

        header.Free;
        pegaHeader := true;
    end;

    {--------------------------------------------------------}

    function abreUrl(url: string; out pBuf: pbufrede; out soquete: integer): boolean;
    var
        protocolo, nomeComput, recurso: string;
        porta: integer;
        novaUrl: string;
        codRetorno: integer;

    begin
        abreUrl := false;
        novaUrl := url;

        codRetorno := 300;
        while (codRetorno div 100) = 3  do
            begin
                if not traduzURL (novaUrl, protocolo, nomeComput, porta, recurso) then
                    exit;

                 if not pegaHeader (protocolo, nomeComput, porta, recurso,
                                   codRetorno, novaUrl, pbuf, soquete) then
                    exit;
           end;

        abreUrl := true;
     end;

{--------------------------------------------------------}

function copiaURLparaArquivo (pbuf: PbufRede; soquete: integer;
                              nomeArqBaixar: string): boolean;
    const
        TAMBUF = 8192;
    var
        arq: file;
        lidoOk: boolean;
        buf: packed array [0..TAMBUF-1] of char;
        ncbuf: integer;
        c: char;
        escritos: integer;
    begin
         copiaURLparaArquivo := false;
         statusUltIO := 0;
         ncbuf := 0;

         assign (arq, nomeArqBaixar);
         {$I-}  rewrite (arq, 1);  {$I+}
         if ioresult <> 0 then
             begin
                 statusUltIO := 1;
                 sintWriteln(ERRO_ESCRITA);
                 exit;
             end;

        // verso futura: checar o content-Length previamente recebido
        // se no tiver vindo, considerar tamanho infinito.

        repeat
            lidoOk := leCaracBufRede(pbuf, c);
            if lidoOk then
                begin
                    buf[ncbuf] := c;
                    ncbuf := ncbuf + 1;
                end;

            if ncbuf >= TAMBUF then
                begin
                    escritos := 0;
                    blockWrite (arq, buf, ncbuf, escritos);
                    if escritos <> ncbuf then
                        begin
                            sintWriteln(ERRO_ESCRITA);
                            statusUltIO := 1;
                            lidoOk := false;
                        end;
                    ncbuf := 0;
                end;
        until not lidoOk;

        closeFile (arq);
        copiaURLparaArquivo := true;
    end;

{--------------------------------------------------------}

var
    url: string;
    nomeArqBaixar: string;
    aceitaErro: boolean;
    pbuf: PbufRede;
    soquete: integer;

label erro;
begin
    processaBaixa := false;
    aceitaErro := false;

    if copy (lido, length(lido), 1) = '&' then
        begin
            aceitaErro := true;
            delete (lido, length(lido), 1);
            lido := trim(lido);
        end;

    if not extraiValor (lido, url) then exit;
    if not extraiValor (lido, nomeArqBaixar) then exit;
    if trim(lido) <> '' then exit;

    if abreUrl(url, pbuf, soquete) then
        begin
            if copiaURLparaArquivo (pbuf, soquete, nomeArqBaixar) or aceitaErro then
                processaBaixa := true;
            fimBufRede(pbuf);
            fechaConexao(soquete);
        end;
end;

end.
