{-------------------------------------------------------------}
{
{    Traduvox - Mdulo de controle da traduo
{
{    Autor: Jose' Antonio Borges
{
{    Em Janeiro/2010
{
{-------------------------------------------------------------}

unit trtraduz;

interface
uses
    windows,
    classes,
    dvcrt,
    dvwin,
    dvExec,
    dvdigitexto,
    sysUtils,
    trvars,
    trmsg,
    trgoogle,
    trsintet,
    trnet;

procedure traduzFrases (tipoDestino: char; nomeArqDest: string);
procedure traduzArquivo (nomeArqOrig: string; tipoDestino: char; nomeArqDest: string);
procedure traduzClipBoard (tipoDestino: char; nomeArqDest: string);

implementation

const
    MAX_TRADUZIR = 30000;

procedure arquiva (s, nomeArq: string; pulandoLinha: boolean);
var arq: textFile;
begin
{
    if nomeArq = '' then
        begin
            sintWriteln (s);
            exit;
        end;
}
    assign (arq, nomeArq);
    try
        if FileExists(nomeArq) then
            append (arq)
        else
            rewrite (arq);
    except
        mensagem ('TRERRARQ', 2);  {'Erro de arquivamento!'}
        exit;
    end;

    if pulandoLinha then
        writeln (arq, s)
    else
        write (arq, s);
    closeFile (arq);
end;

procedure jogaAreaTransf (s2: string);
var textoClip: array [0..65000] of char;
    c, c2: char;
begin
    mensagem ('TRSUBADI', 1);  {'Substitui ou adiciona?'}
    sintLeTecla (c, c2);
    writeln;

    if upcase (c) = 'S' then
        textoClip [0] := #$0
    else
        begin
            getClipBoard(textoClip, 65000-2-length(s2));
            if textoClip[0] <> #$0 then
                s2 := CRLF + s2;
        end;

    strCat (textoClip, pchar(s2));
    putClipBoard(textoClip);

    mensagem ('TRTRANSF', 1);   {'Ok, transferido'}
end;

procedure trocaVoz (tipo: string);
var
    tipoSapi, numVoz: integer;
begin
    obtemVoz (tipo, tipoSapi, numVoz);
    case tipoSapi of
        3: sintReinic (3, true, 3, numVoz, 0, 0);
        4: sintReinic (3, true, 4, numVoz, 140, 80);
        5: sintReinic (3, true, 5, numVoz, 0, 0);
    end;
end;

procedure traduzFraseDireta (tipoDestino: char; s: string);
var
    status: string;
    s2: string;
    dir: string;
    tempPath, tempFile: packed array [0..MAX_PATH] of char;
    nomeTemp: string;
begin
    GetTempPath(sizeof(tempPath), tempPath);
    if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
        begin
            mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
            exit;
        end;
    nomeTemp := strPas(tempFile);

    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);
    nomeTemp := ChangeFileExt(nomeTemp, '.txt');
    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);

//    status := traduzFraseGoogle (s, linguaOrig, s2, linguaDest);
    status := traduzArquivoGoogle (nomeTemp, s, linguaOrig, s2, linguaDest);

    if copy (status, 1, 3)  <> '200' then
        begin
            mensagem ('TRERRO', 1);   {'Erro no Google Translator, cdigo:'}
            sintWriteln (status);
        end
    else
        case tipoDestino of
            'L':
                  begin
                      mensagem ('TREDIT', 1);   {'Editore a resposta'}
                      while sintFalando do delay (500);
                      if sapiPresente then
                          trocaVoz (linguaDest);
                      sintetiza (s2);
                      sintEdita (s2, wherex, wherey, 255, true);
                      if sapiPresente then
                      begin
                          sintFim;
                          dir := sintAmbiente ('TRADUVOX', 'DIRTRADUVOX');
                          if dir = '' then
                              dir := 'c:\winvox\som\traduvox';
                          sintInic (0, dir);
                      end;
                  end;
            'A':  arquiva (s2, nomeArqDest, true);
            'T':  jogaAreaTransf (s2);
        end;

    writeln;
end;

procedure traduzFrases (tipoDestino: char; nomeArqDest: string);
var s: string;
begin
    clrscr;
    textBackground (BLUE);
    write (pegaTextoMensagem ('TRINIC'));    {'TRADUVOX ...'}
    writeln (versao);
    writeln;
    textBackground (BLACK);
    mensagem ('TRINITRD', 2);  {'Iniciando a traduo'}
    mensagem ('TRTECFR1', 1);  {'Tecle cada frase a traduzir.'}
    mensagem ('TRTECFR2', 1);  {'ESC termina.'}
    mensagem ('TRTECFR3', 2);  {'Use as setas para obter os detalhes da traduo.'}

    //if not abreGoogle('1.1') then exit;   // 1.0 fecha conexo aps resposta

    while true do
        begin
            mensagem ('TRTECFRA', 1);  {'Tecle a frase:'}
            sintReadln (s);
            if s = '' then break;
            traduzFraseDireta (tipoDestino, s);
        end;

    //    fechaGoogle;
end;

procedure exibeLista (listaResult: TStringList);
var i: integer;
    dir: string;
begin
    if sapiPresente then
        trocaVoz (linguaDest);

    for i := 0 to listaResult.Count-1 do
        sintWriteln (listaResult[i]);
    textBackground (RED);

    if sapiPresente then
    begin
        sintFim;
        dir := sintAmbiente ('TRADUVOX', 'DIRTRADUVOX');
        if dir = '' then
            dir := 'c:\winvox\som\traduvox';
        sintInic (0, dir);
    end;

    mensagem ('TRTECENT', 0);   {'Tecle enter '}
    textBackground (BLACK);
    readln;

end;

procedure traduzArquivo (nomeArqOrig: string; tipoDestino: char; nomeArqDest: string);
var
    nomeArqTrab: string;
    status: string;

    tempPath, tempFile: array [0..MAX_PATH] of char;
    textoOriginal: TStringList;
    listaResult: TStringList;

    autoParag:  boolean;

    tamanhoOriginal: integer;
    x, y: integer;
    c1, c2: char;
    p, i:  integer;
    paragrafo,
    acumulado,
    aTraduzir,
    traduzido: string;

label cancela;
begin
    try
        if FileExists(nomeArqOrig) then
        begin
            textoOriginal := TStringList.Create;
            textoOriginal.LoadFromFile(nomeArqOrig);
        end
        else
        begin
            mensagem ('TRARQNAO', 2);  {'Arquivo no existe'}
            exit;
        end;
    except
        mensagem ('TRERRABR', 2);  {'Erro ao abrir o arquivo!'}
        exit;
    end;

    if length (textoOriginal.Text) > MAX_TRADUZIR then
        begin
            mensagem ('TREXCED', 2);   {'O texto excedeu 32000 letras e ser truncado.'}
        end;

    if nomeArqDest <> '' then
        nomeArqTrab := nomeArqDest
    else
        begin
            GetTempPath(sizeof(tempPath), tempPath);
            if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
                begin
                    mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
                    exit;
                end;
            nomeArqTrab := strPas(tempFile);
        end;

    if not interativo then
        autoParag := true
    else
        begin
            mensagem ('TRPOSPAR', 0);   {'Posso paragrafar automaticamente? '}
            sintLeTecla (c1, c2);
            writeln;
            writeln;
            if c1 = ESC then exit;
            autoParag := upcase(c1) <> 'N';
        end;

    mensagem ('TRINITRD', 2);  {'Iniciando a traduo'}

    // if not abreGoogle('1.1') then exit;   // 1.1 conexo aberta para novas perguntas

    acumulado := '';
    tamanhoOriginal := 0;
    for i := 0 to textoOriginal.Count-1 do
        begin
            paragrafo := textoOriginal.Strings[i];
            if acumulado = '' then
                acumulado := paragrafo
            else
                if autoParag and (
                    (trim (paragrafo) <> '') and
                    (copy (paragrafo, 1, 1) <> ' ') and
                    (copy (paragrafo, 1, 1) <> ^I) ) then
                    acumulado := acumulado + ' ' + trim(paragrafo)
                else
                    acumulado := acumulado + '<p>' + #$0d + #$0a + paragrafo;
            tamanhoOriginal := tamanhoOriginal + length(paragrafo);
            if tamanhoOriginal > MAX_TRADUZIR then
                break;
        end;

    aTraduzir := copy (acumulado, 1, length(acumulado));
    if aTraduzir [length(aTraduzir)] <> #$0a then
       aTraduzir := aTraduzir + ' ';
    status := traduzArquivoGoogle (nomeArqOrig, aTraduzir, linguaOrig, traduzido, linguaDest);
    if (copy (status,1,3)  <> '200') then
          begin
              mensagem ('TRERRO', 1);   // 'Erro no Google Translator, cdigo:'
              sintWriteln (status);
              mensagem ('TRPARAG', 1);  // 'Pargrafo do erro:'
              sintWriteln (paragrafo);
              goto cancela;
          end;
    if (copy (traduzido, length(traduzido)-2, 3) <> '<p>') or
       (copy (traduzido, length(traduzido)-2, 3) <> '<P>') then
        traduzido := traduzido + ' ';   // para no colapsar pargrafos divididos
    p := pos ('<p>', traduzido);
    if p = 0 then
        p := pos ('<P>', traduzido);
    while p <> 0 do
        begin
            if copy (traduzido, p+2, 2) = '> ' then
                delete (traduzido, p, 4)
            else
                delete (traduzido, p, 3);
            p := pos ('<p>', traduzido);
            if p = 0 then
                p := pos ('<P>', traduzido);
        end;
    arquiva (traduzido, nomeArqTrab, false);

cancela:
    limpaBufTec;
    if tipoDestino = 'A' then
        mensagem ('TRARQVAD', 1)        // 'Arquivado'
    else
        begin
            listaResult := TStringList.create;
            listaResult.LoadFromFile(nomeArqTrab);

            if tipoDestino = 'L' then
            begin
//                exibeLista (listaResult)
                x := wherex;
                y := wherey;
                popupDigiTexto (listaResult, false, true, 2, 2, 79, 24, true);
                gotoxy (x,y);
            end
            else
            if tipoDestino = 'T' then
                begin
                    traduzido := listaResult.Text;
                    putClipBoard(pchar(traduzido+#$0));
                    mensagem ('TRTXTTRAD', 1);  {'Texto traduzido'}
                end;

            listaResult.free;
            deleteFile (nomeArqTrab);
    end;
end;

procedure AntigaTradArq (nomeArqOrig: string; tipoDestino: char; nomeArqDest: string);
var
    p: integer;
    nomeArqTrab: string;
    arq: textFile;
    salva: byte;
    paragrafo, s: string;
    status: string;
    aTraduzir, traduzido, acumulado: string;
    listaResult: TStringList;
    tempPath, tempFile: array [0..MAX_PATH] of char;
    c1, c2: char;
    autoParag: boolean;

label cancela;
begin
    sintWriteln ('A traduo multilinha est temporariamente proibida');
    exit;

    salva := Filemode;
    FileMode := 0;
    assign (arq, nomeArqOrig);
    try
        if FileExists(nomeArqOrig) then
            reset (arq)
        else
            begin
                mensagem ('TRARQNAO', 2);  {'Arquivo no existe'}
                exit;
            end;
    except
        fileMode := salva;
        mensagem ('TRERRABR', 2);  {'Erro ao abrir o arquivo!'}
        exit;
    end;
    fileMode := salva;

    if tipoDestino = 'A' then
        nomeArqTrab := nomeArqDest
    else
        begin
            GetTempPath(sizeof(tempPath), tempPath);
            if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
                begin
                    mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
                    exit;
                end;
            nomeArqTrab := strPas(tempFile);
        end;

    if not interativo then
        autoParag := true
    else
        begin
            mensagem ('TRPOSPAR', 0);   {'Posso paragrafar automaticamente? '}
            sintLeTecla (c1, c2);
            writeln;
            if c1 = ESC then exit;
            autoParag := c1 <> 'N';
        end;

    mensagem ('TRINITRD', 2);  {'Iniciando a traduo'}

    // if not abreGoogle('1.1') then exit;   // 1.1 conexo aberta para novas perguntas

    acumulado := '';
    while not eof (arq) do
        begin
            readln (arq, paragrafo);

            if acumulado = '' then
                acumulado := paragrafo
            else
                if autoParag and (
                    (trim (paragrafo) <> '') and
                    (copy (paragrafo, 1, 1) <> ' ') and
                    (copy (paragrafo, 1, 1) <> ^I) ) then
                    acumulado := acumulado + ' ' + trim(paragrafo)
                else
                    acumulado := acumulado + '<p>' + #$0d + #$0a + paragrafo;

            // limita cadeia enviada ao Google em 800
            while (length (acumulado) > 200) or
                  ((length(acumulado) <> 0) and eof(arq)) do    // trata caso do ltimo registro
                begin
                    s := copy (acumulado, 201, length (acumulado));
                    p := pos ('<p>', s) + 3;    // seria melhor traduzir de trs para diante...
                    if (p <= 3) or (p > 100) then
                        begin
                            p := pos ('.', s) + 1;
                            if (p <= 1) or (p > 100) then
                                begin
                                    p := pos (' ', s);
                                    if p > 100 then p := 0;
                                end;
                        end;

                    p := p + 700;
                    aTraduzir := copy (acumulado, 1, p);
                    if aTraduzir [length(aTraduzir)] <> #$0a then
                       aTraduzir := aTraduzir + ' ';
                    delete (acumulado, 1, p);

                    // writeln (aTraduzir);
                    // writeln ('enviarei: ', length(aTraduzir), ' tecle enter');
                    // readln;

//                    status := traduzFraseGoogle (aTraduzir, linguaOrig, traduzido, linguaDest);
                    status := traduzArquivoGoogle ('', aTraduzir, linguaOrig, traduzido, linguaDest);
                    if copy (status, 1, 3) <> '200' then
                          begin
                              mensagem ('TRERRO', 1);   {'Erro no Google Translator, cdigo:'}
                              sintWriteln (status);
                              mensagem ('TRPARAG', 1);  {'Pargrafo do erro:'}
                              sintWriteln (paragrafo);
                              goto cancela;
                          end;

                    if copy (traduzido, length(traduzido)-2, 3) <> '<p>' then
                        traduzido := traduzido + ' ';   // para no colapsar pargrafos divididos
                    p := pos ('<p>', traduzido);
                    while p <> 0 do
                        begin
                            traduzido [p] := #$0d;
                            traduzido [p+1] := #$0a;
                            if copy (traduzido, p+2, 2) = '> ' then
                                delete (traduzido, p+2, 2)
                            else
                                delete (traduzido, p+2, 1);
                            p := pos ('<p>', traduzido);
                        end;

                    // textColor (lightGreen);
                    // writeln ('Traduzido:', traduzido);
                    // textColor (white);

                    arquiva (traduzido, nomeArqTrab, false);

                    if not keypressed then
                        sintClek
                    else
                        if (not interativo) and (nomeArqDest = '') then
                            begin
                                if readkey = ESC then goto cancela;
                            end;
                 end;
        end;

cancela:
    closeFile (arq);
    //fechaGoogle;

    limpaBufTec;
    if tipoDestino = 'A' then
        begin
            if interativo or (nomeArqDest <> '') then
                mensagem ('TRARQVAD', 1);  {'Arquivado'}
        end
    else
        begin
            listaResult := TStringList.create;
            listaResult.LoadFromFile(nomeArqTrab);

            if tipoDestino = 'L' then
                exibeLista (listaResult)
            else
            if tipoDestino = 'T' then
                begin
                    traduzido := listaResult.Text;
                    putClipBoard(pchar(traduzido+#$0));
                end;

            listaResult.free;
            deleteFile (nomeArqTrab);
    end;
end;

procedure traduzClipBoard (tipoDestino: char; nomeArqDest: string);
var data: packed array [0..MAX_TRADUZIR] of char;
    tempPath, tempFile: packed array [0..MAX_PATH] of char;
    nomeTemp: string;
    arqTemp: file;
//    s,
//    p: integer;
//    f1, f2: boolean;
begin

    getClipBoard(data, MAX_TRADUZIR+1);
    if strLen (data) > MAX_TRADUZIR then
        begin
            mensagem ('TRLIMIT', 2);   {'Truncando! A rea de transferncia excedeu 64000 letras'}
            data[MAX_TRADUZIR] := #$0;
        end;

{@@@
    Agora est funcionando multilinha chamando traduzArquivo.
    s := strPas (data);
    delete (s, 150, 9999);
    p := pos(#$0d, s);
    if p <> 0 then delete (s, p, 9999);
    p := pos(#$0a, s);
    if p <> 0 then delete (s, p, 9999);
    traduzFraseDireta (tipoDestino, s);
    exit;
}

    // a traduo multilinha do clipboard est temporariamente bloqueada

    GetTempPath(sizeof(tempPath), tempPath);
    if GetTempFileName (tempPath, 'tmp', 0, tempFile) = 0 then
        begin
            mensagem ('TRERTRAB', 2);   {'Erro ao criar o arquivo de trabalho'}
            exit;
        end;
    nomeTemp := strPas(tempFile);

    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);
    nomeTemp := ChangeFileExt(nomeTemp, '.txt');
    if fileExists(nomeTemp) then
        DeleteFile(nomeTemp);

    assignFile (arqTemp, nomeTemp);
    rewrite (arqTemp, 1);
    blockWrite (arqTemp, data, strlen(data));
    closeFile (arqTemp);

    traduzArquivo (nomeTemp, tipoDestino, nomeArqDest);

    DeleteFile(nomeTemp);
end;

end.

